
//
//  PBoolEx.h - Packed Boolean Logic
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the rotation module header.
//
//  Created - 27 Dec, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include	"CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PBoolEx_H
#define __PBoolEx_H

#ifdef __cplusplus
extern "C" {
#endif



void PBoolSetup( const CpuInfo * const pcinfo );


void vmp_pnotGeneric(   void * const pvD, const void * const pvA );
void vmp_pnotPPC(       void * const pvD, const void * const pvA );
void vmp_pnotAltivec(   void * const pvD, const void * const pvA );
void vmp_pnotAltivec0(  void * const pvD, const void * const pvA );

void vmp_pandGeneric(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandPPC(       void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandAltivec(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandAltivec0(  void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pandcGeneric(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcPPC(      void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcAltivec(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcAltivec0( void * const pvD, const void * const pvA, const void * const pvB );

void vmp_porGeneric(    void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porPPC(        void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porAltivec(    void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porAltivec0(   void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pxorGeneric(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorPPC(       void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorAltivec(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorAltivec0(  void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pnorGeneric(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorPPC(       void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorAltivec(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorAltivec0(  void * const pvD, const void * const pvA, const void * const pvB );



#ifdef __cplusplus
}
#endif

#endif  //__PBoolEx_H





