
//
//  PRotEx.h - Packed Rotation
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the rotation module header.
//
//  Created - 1 Sep, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include	"CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PRotEx_H
#define __PRotEx_H

#ifdef __cplusplus
extern "C" {
#endif


void PRotSetup( const CpuInfo * const pcinfo );

	//	Shift Right Arithmetic

void vmp_psraBGeneric( int8  * const pbD, const int8  * const pbA, uint count );
void vmp_psraBPPC(     int8  * const pbD, const int8  * const pbA, uint count );
void vmp_psraBAltivec(  int8  * const pbD, const int8  * const pbA, uint count );
void vmp_psraBAltivec0(  int8  * const pbD, const int8  * const pbA, uint count );

void vmp_psraHGeneric( int16 * const phD, const int16 * const phA, uint count );
void vmp_psraHPPC(     int16 * const phD, const int16 * const phA, uint count );
void vmp_psraHAltivec( int16 * const phD, const int16 * const phA, uint count );
void vmp_psraHAltivec0( int16 * const phD, const int16 * const phA, uint count );

void vmp_psraWGeneric( int32 * const pwD, const int32 * const pwA, uint count );
void vmp_psraWPPC(     int32 * const pwD, const int32 * const pwA, uint count );
void vmp_psraWAltivec( int32 * const pwD, const int32 * const pwA, uint count );
void vmp_psraWAltivec0( int32 * const pwD, const int32 * const pwA, uint count );

void vmp_psra1BGeneric( int8  * const pbD, const int8  * const pbA );
void vmp_psra1BPPC(     int8  * const pbD, const int8  * const pbA );
void vmp_psra1BAltivec( int8  * const pbD, const int8  * const pbA );
void vmp_psra1BAltivec0( int8  * const pbD, const int8  * const pbA );

void vmp_psra1HGeneric( int16 * const phD, const int16 * const phA );
void vmp_psra1HPPC(     int16 * const phD, const int16 * const phA );
void vmp_psra1HAltivec( int16 * const phD, const int16 * const phA );
void vmp_psra1HAltivec0( int16 * const phD, const int16 * const phA );

void vmp_psra1WGeneric( int32 * const pwD, const int32 * const pwA );
void vmp_psra1WPPC(     int32 * const pwD, const int32 * const pwA );
void vmp_psra1WAltivec( int32 * const pwD, const int32 * const pwA );
void vmp_psra1WAltivec0( int32 * const pwD, const int32 * const pwA );

	//	Shift Left Logical

void vmp_psllBGeneric( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psllBPPC(     uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psllBAltivec( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psllBAltivec0( uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_psllHGeneric( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psllHPPC(     uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psllHAltivec( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psllHAltivec0( uint16 * const phD, const uint16 * const phA, uint count );

void vmp_psllWGeneric( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psllWPPC(     uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psllWAltivec( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psllWAltivec0( uint32 * const pwD, const uint32 * const pwA, uint count );

void vmp_psll1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_psll1BPPC(     uint8  * const pbD, const uint8  * const pbA );
void vmp_psll1BAltivec( uint8  * const pbD, const uint8  * const pbA );
void vmp_psll1BAltivec0( uint8  * const pbD, const uint8  * const pbA );

void vmp_psll1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_psll1HPPC(     uint16 * const phD, const uint16 * const phA );
void vmp_psll1HAltivec( uint16 * const phD, const uint16 * const phA );
void vmp_psll1HAltivec0( uint16 * const phD, const uint16 * const phA );

void vmp_psll1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_psll1WPPC(     uint32 * const pwD, const uint32 * const pwA );
void vmp_psll1WAltivec( uint32 * const pwD, const uint32 * const pwA );
void vmp_psll1WAltivec0( uint32 * const pwD, const uint32 * const pwA );

	//	Shift Right Logical

void vmp_psrlBGeneric( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psrlBPPC(     uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psrlBAltivec( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psrlBAltivec0( uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_psrlHGeneric( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psrlHPPC(     uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psrlHAltivec( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psrlHAltivec0( uint16 * const phD, const uint16 * const phA, uint count );

void vmp_psrlWGeneric( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psrlWPPC(     uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psrlWUAltivec( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psrlWUAltivec0( uint32 * const pwD, const uint32 * const pwA, uint count );

void vmp_psrl1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_psrl1BPPC(     uint8  * const pbD, const uint8  * const pbA );
void vmp_psrl1BAltivec( uint8  * const pbD, const uint8  * const pbA );
void vmp_psrl1BAltivec0( uint8  * const pbD, const uint8  * const pbA );

void vmp_psrl1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_psrl1HPPC(     uint16 * const phD, const uint16 * const phA );
void vmp_psrl1HAltivec( uint16 * const phD, const uint16 * const phA );
void vmp_psrl1HAltivec0( uint16 * const phD, const uint16 * const phA );

void vmp_psrl1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_psrl1WPPC(     uint32 * const pwD, const uint32 * const pwA );
void vmp_psrl1WAltivec( uint32 * const pwD, const uint32 * const pwA );
void vmp_psrl1WAltivec0( uint32 * const pwD, const uint32 * const pwA );

	//	Rotate Left

void vmp_prolBGeneric( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_prolBPPC(     uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_prolBAltivec( uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_prolBAltivec0( uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_prolHGeneric( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_prolHPPC(     uint16 * const phD, const uint16 * const phA, uint count );
void vmp_prolHAltivec( uint16 * const phD, const uint16 * const phA, uint count );
void vmp_prolHAltivec0( uint16 * const phD, const uint16 * const phA, uint count );

void vmp_prolWGeneric( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_prolWPPC(     uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_prolWAltivec( uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_prolWAltivec0( uint32 * const pwD, const uint32 * const pwA, uint count );

void vmp_prol1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_prol1BPPC(     uint8  * const pbD, const uint8  * const pbA );
void vmp_prol1BAltivec( uint8  * const pbD, const uint8  * const pbA );
void vmp_prol1BAltivec0( uint8  * const pbD, const uint8  * const pbA );

void vmp_prol1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_prol1HPPC(     uint16 * const phD, const uint16 * const phA );
void vmp_prol1HAltivec( uint16 * const phD, const uint16 * const phA );
void vmp_prol1HAltivec0( uint16 * const phD, const uint16 * const phA );

void vmp_prol1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_prol1WPPC(     uint32 * const pwD, const uint32 * const pwA );
void vmp_prol1WAltivec( uint32 * const pwD, const uint32 * const pwA );
void vmp_prol1WAltivec0( uint32 * const pwD, const uint32 * const pwA );



#ifdef __cplusplus
}
#endif

#endif  //__PRotEx_H





