
//
//  PasEx.h - Packed Addition/Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//		This module is designed for fast 3D math
//
//  Created - 31 Dec, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include	"CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PasEx_H
#define __PasEx_H

#ifdef __cplusplus
extern "C" {
#endif


void PasSetup( const CpuInfo * const pcinfo );

	//	Addition (Un)signed

void vmp_paddBGeneric(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddBAltivec(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddBAltivec0( uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_paddHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddHAltivec(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddHAltivec0( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );

void vmp_paddWGeneric(  uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_paddWAltivec(  uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_paddWAltivec0( uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );

	//	Subtraction (Un)signed

void vmp_psubBGeneric(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubBAltivec(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubBAltivec0( uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_psubHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubHAltivec(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubHAltivec0( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );

void vmp_psubWGeneric(  uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_psubWAltivec(  uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
void vmp_psubWAltivec0( uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );

	//	Addition signed Saturation

void vmp_paddsBGeneric(  int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_paddsBAltivec(  int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_paddsBAltivec0( int8  * const pbD, const int8  * const pbA, const int8  * const pbB );

void vmp_paddsHGeneric(   int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_paddsHAltivec(   int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_paddsHAltivec0(  int16 * const phD, const int16 * const phA, const int16 * const phB );

	//	Subtraction signed Saturation

void vmp_psubsBGeneric(  int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_psubsBAltivec(  int8  * const pbD, const int8  * const pbA, const int8  * const pbB );
void vmp_psubsBAltivec0( int8  * const pbD, const int8  * const pbA, const int8  * const pbB );

void vmp_psubsHGeneric(  int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_psubsHAltivec(  int16 * const phD, const int16 * const phA, const int16 * const phB );
void vmp_psubsHAltivec0( int16 * const phD, const int16 * const phA, const int16 * const phB );

	//	Addition unsigned Saturation

void vmp_paddusBGeneric(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddusBAltivec(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_paddusBAltivec0( uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_paddusHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddusHAltivec(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_paddusHAltivec0( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );

	//	Subtraction unsigned Saturation

void vmp_psubusBGeneric(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubusBAltivec(  uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_psubusBAltivec0( uint8  * const pbD, const uint8  * const pbA, const uint8  * const pbB );

void vmp_psubusHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubusHAltivec(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_psubusHAltivec0( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );


#ifdef __cplusplus
}
#endif

#endif  //__PasEx_H





