
//
//	Vas3D.cpp - 3D Vector Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

	//	3rd Party Libraries
	
#include	<assert.h>
#include	<iostream.h>

    //  Book Development Library Modules

#include	"vmp3D.h"
#include	"vmp3DEx.h"
#include	"Vas3D.h"									// 3D Math
#include	"Vas3DEx.h"


vmp_VecAddProc				vmp_VecAdd;
vmp_VecAddProc				vmp_VecAdd0;
vmp_VecSubProc				vmp_VecSub;
vmp_VecSubProc				vmp_VecSub0;
vmp_VecAddScalarProc		vmp_VecAddScalar;
vmp_VecAddScalarProc		vmp_VecAddScalar0;
vmp_VecSubScalarProc		vmp_VecSubScalar;
vmp_VecSubScalarProc		vmp_VecSubScalar0;




//
//	Vector Summation (Addition)
//

void vmp_VecAddGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB)
{	
	ASSERT_PTR4(pvD);
	ASSERT_PTR4(pvA);
	ASSERT_PTR4(pvB);
	
	pvD->x = pvA->x + pvB->x;
	pvD->y = pvA->y + pvB->y;
	pvD->z = pvA->z + pvB->z;
}



//
//	Vector Difference (Subtraction)
//

void vmp_VecSubGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB)
{	
	ASSERT_PTR4(pvD);
	ASSERT_PTR4(pvA);
	ASSERT_PTR4(pvB);
	
	pvD->x = pvA->x - pvB->x;
	pvD->y = pvA->y - pvB->y;
	pvD->z = pvA->z - pvB->z;
}



//
//	Vector Scalar Summation (Addition)
//

void vmp_VecAddScalarGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar)
{	
	ASSERT_PTR4(pvD);
	ASSERT_PTR4(pvA);
	
	pvD->x = pvA->x + fScalar;
	pvD->y = pvA->y + fScalar;
	pvD->z = pvA->z + fScalar;
}



//
//	Vector Scalar Difference (Subtraction)
//

void vmp_VecSubScalarGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar)
{	
	ASSERT_PTR4(pvD);
	ASSERT_PTR4(pvA);
	
	pvD->x = pvA->x - fScalar;
	pvD->y = pvA->y - fScalar;
	pvD->z = pvA->z - fScalar;
}







