  
//
//  Vas3D.h - 3D Math Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include	"vmp3D.h"


#ifndef __Vas3D_H
#define __Vas3D_H

#ifdef __cplusplus
extern "C" {
#endif




//
//	Vector Summation (Addition)
//
typedef void (*vmp_VecAddProc)(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
extern vmp_VecAddProc vmp_VecAdd;
extern vmp_VecAddProc vmp_VecAdd0;

//
//	Vector Difference (Subtraction)
//
typedef void (*vmp_VecSubProc)(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
extern vmp_VecSubProc vmp_VecSub;
extern vmp_VecSubProc vmp_VecSub0;

//
//	Vector Scalar Summation (Addition)
//
typedef void (*vmp_VecAddScalarProc)( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
extern vmp_VecAddScalarProc vmp_VecAddScalar;
extern vmp_VecAddScalarProc vmp_VecAddScalar0;

//
//	Vector Scalar Difference (Subtraction)
//
typedef void (*vmp_VecSubScalarProc)( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
extern vmp_VecSubScalarProc vmp_VecSubScalar;
extern vmp_VecSubScalarProc vmp_VecSubScalar0;






#ifdef __cplusplus
}
#endif

#endif	//__Vas3D_H


