
//
//	FmdAltivec.cpp - (Scalar) Vector Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include "KariType.h"                                   // Master Definitions

	//	3rd Party Libraries
	
#include	<assert.h>
#include	<iostream.h>
#include    <math.h>

    //  Book Development Library Modules

#include	"CpuAsm.h"									// CPU
#include	"vmp3D.h"
#include	"vmp3DEx.h"
#include	"Fmd.h"										// (float) Math
#include	"FmdEx.h"



//
//	Setup (float) Add/Sub module
//
//	NOTE: This function sets up the function vectors so the best function
//		is attached to the vector for the processor running.
//

void FmdSetup( const CpuInfo * const pcinfo )
{
	ASSERT_PTR4(pcinfo);
	
    if ( CPUBITS_ALTIVEC & pcinfo->nBits )
      {
		vmp_FMul =				vmp_FMulGeneric;
		vmp_FDiv =				vmp_FDivGeneric;
		vmp_FDivFast =			vmp_FDivGeneric;
	  }

	else
	  {
		vmp_FMul =				vmp_FMulGeneric;
		vmp_FDiv =				vmp_FDivGeneric;
		vmp_FDivFast =			vmp_FDivGeneric;
	  }
}





