
//
//  PmdEx.h - Packed Multiplication/Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//		This module is designed for fast 3D math
//
//  Created - 31 Dec, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include	"CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PmdEx_H
#define __PmdEx_H

#ifdef __cplusplus
extern "C" {
#endif


void PmdSetup( const CpuInfo * const pcinfo );



	//	Multiplication Highs & lows

void vmp_pmulhBGeneric(    int8 * const pbD,  const  int8  * const pbA, const  int8 * const pbB );
void vmp_pmulhuBGeneric(  uint8 * const pbD,  const uint8  * const pbA, const uint8 * const pbB );
void vmp_pmulluBGeneric(  uint8 * const pbD,  const uint8  * const pbA, const uint8 * const pbB );
#define vmp_pmullBGeneric(d,a,b) vmp_pmulluBGeneric((uint8*)d, (uint8*)a, (uint8*)b)

void vmp_pmulhHGeneric(     int16 * const phD, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulhHAltivec(  int16 * const phD, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulhHAltivec0( int16 * const phD, const  int16 * const phA, const  int16 * const phB );

void vmp_pmulhuHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulhuHAltivec(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulhuHAltivec0( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );

void vmp_pmulluHGeneric(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulluHAltivec(  uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulluHAltivec0( uint16 * const phD, const uint16 * const phA, const uint16 * const phB );
#define vmp_pmullHGeneric(d,a,b) vmp_pmulluHGeneric((uint16*)d, (uint16*)a, (uint16*)b)

void vmp_pmulluWGeneric( uint32 * const pwD, const uint32 * const pwA, const uint32 * const pwB );
#define vmp_pmullWGeneric(d,a,b) vmp_pmulluWGeneric((uint32*)d, (uint32*)a, (uint32*)b)

	//	Multiplication Hi/Lo

void vmp_pmulhlBGeneric(   int8  * const pbHi,  int8  * const pbLo, const  int8  * const pbA, const  int8  * const pbB );
void vmp_pmulhluBGeneric( uint8  * const pbHi, uint8  * const pbLo, const uint8  * const pbA, const uint8  * const pbB );

void vmp_pmulhlHGeneric(   int16 * const phHi,  int16 * const phLo, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulhlHAltivec(   int16 * const phHi,  int16 * const phLo, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulhlHAltivec0(  int16 * const phHi,  int16 * const phLo, const  int16 * const phA, const  int16 * const phB );

void vmp_pmulhluHGeneric(  uint16 * const phHi, uint16 * const phLo, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulhluHAltivec(  uint16 * const phHi, uint16 * const phLo, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulhluHAltivec0( uint16 * const phHi, uint16 * const phLo, const uint16 * const phA, const uint16 * const phB );

	//	Multiplication Odd/Even

void vmp_pmullueBGeneric( uint16 * const phD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_pmulluoBGeneric( uint16 * const phD, const uint8  * const pbA, const uint8  * const pbB );
void vmp_pmulleBGeneric(   int16 * const phD, const  int8  * const pbA, const  int8  * const pbB );
void vmp_pmulloBGeneric(   int16 * const phD, const  int8  * const pbA, const  int8  * const pbB );

void vmp_pmullueHGeneric(  uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmullueHAltivec(  uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmullueHAltivec0( uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );

void vmp_pmulluoHGeneric(  uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulluoHAltivec(  uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );
void vmp_pmulluoHAltivec0( uint32 * const pwD, const uint16 * const phA, const uint16 * const phB );

void vmp_pmulleHGeneric(   int32 * const pwD, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulleHAltivec(   int32 * const pwD, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulleHAltivec0(  int32 * const pwD, const  int16 * const phA, const  int16 * const phB );

void vmp_pmulloHGeneric(   int32 * const pwD, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulloHAltivec(   int32 * const pwD, const  int16 * const phA, const  int16 * const phB );
void vmp_pmulloHAltivec0(  int32 * const pwD, const  int16 * const phA, const  int16 * const phB );



#ifdef __cplusplus
}
#endif

#endif  //__PmdEx_H





