  
//
//  QVmd3DEx.h - (Quad) 3D Math Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include	"CpuAsm.h"
#include	"vmp3D.h"


#ifndef __QVmd3DEx_H
#define __QVmd3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void QVmd3DSetup( const CpuInfo * const pcinfo );

void vmp_QVecMulGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecMulAltivec( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QVecMulAltivec0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QVecScaleGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScale );
void vmp_QVecScaleAltivec( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScale );
void vmp_QVecScaleAltivec0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScale );

void vmp_QVecMAddGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMAddAltivec( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMAddAltivec0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);

void vmp_QVecMSubGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMSubAltivec( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
void vmp_QVecMSubAltivec0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);

void vmp_QVecDivGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivAltivec( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivAltivec0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivFastAltivec( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
void vmp_QVecDivFastAltivec0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);

void vmp_QDotProductGeneric(float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QDotProductAltivec(float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QDotProductAltivec0(float * const pfD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);

void vmp_QCrossProductGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QCrossProductAltivec( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
void vmp_QCrossProductAltivec0(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);


#ifdef __cplusplus
}
#endif

#endif	//__QVmd3DEx_H


