  
//
//  Vmd3D.h - 3D Math Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include	"vmp3D.h"


#ifndef __Vmd3D_H
#define __Vmd3D_H

#ifdef __cplusplus
extern "C" {
#endif



//
//	Product (Multiplication)
//
typedef void (*vmp_VecMulProc)( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
extern vmp_VecMulProc vmp_VecMul;
extern vmp_VecMulProc vmp_VecMul0;


//
//	Scale (Scalar Multiplication)
//
typedef void (*vmp_VecScaleProc)(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScale );
extern vmp_VecScaleProc vmp_VecScale;
extern vmp_VecScaleProc vmp_VecScale0;


//
//	Product (Multiplication-Addition)
//
typedef void (*vmp_VecMAddProc)( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
extern vmp_VecMAddProc vmp_VecMAdd;
extern vmp_VecMAddProc vmp_VecMAdd0;



//
//	Product (Multiplication-Subtraction)
//
typedef void (*vmp_VecMSubProc)( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
extern vmp_VecMSubProc vmp_VecMSub;
extern vmp_VecMSubProc vmp_VecMSub0;



//
//	(Scalar Division)
//
typedef void (*vmp_VecDivProc)(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScale );
extern vmp_VecDivProc vmp_VecDiv;
extern vmp_VecDivProc vmp_VecDiv0;
extern vmp_VecDivProc vmp_VecDivFast;
extern vmp_VecDivProc vmp_VecDivFast0;


//
//	Dot Product
//
typedef void (*vmp_DotProductProc)(float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);
extern vmp_DotProductProc vmp_DotProduct;
extern vmp_DotProductProc vmp_DotProduct0;


//
//	Cross Product
//
typedef void (*vmp_CrossProductProc)(vmp3DVector * const vD, const vmp3DVector * const vA, const vmp3DVector * const vB);
extern vmp_CrossProductProc vmp_CrossProduct;
extern vmp_CrossProductProc vmp_CrossProduct0;




#ifdef __cplusplus
}
#endif

#endif	//__Vmd3D_H


