  
//
//  QVsf3D.h - 3D (Quad) Math Special Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include	"CpuAsm.h"

#include	"vmp3D.h"


#ifndef __QVsf3D_H
#define __QVsf3D_H

#ifdef __cplusplus
extern "C" {
#endif







//                            | 1 0 0 0 |
//	Matrix - Set Identity     | 0 1 0 0 |
//                            | 0 0 1 0 |
//                            | 0 0 0 1 |
typedef void (*vmp_MatrixSetIdentityProc)( vmp3DMatrix * const pMatrix );
extern vmp_MatrixSetIdentityProc vmp_MatrixSetIdentity;



//
//	Vector Square Root
//
typedef void (*vmp_QVecSqrtProc)(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
extern vmp_QVecSqrtProc				vmp_QVecSqrt;
extern vmp_QVecSqrtProc				vmp_QVecSqrt0;
extern vmp_QVecSqrtProc				vmp_QVecSqrtFast;
extern vmp_QVecSqrtProc				vmp_QVecSqrtFast0;


//
//	Vector Minimize
//
typedef void (*vmp_QVecMinProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
extern vmp_QVecMinProc				vmp_QVecMin;
extern vmp_QVecMinProc				vmp_QVecMin0;


//
//	Vector Maximize
//
typedef void (*vmp_QVecMaxProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
extern vmp_QVecMaxProc				vmp_QVecMax;
extern vmp_QVecMaxProc				vmp_QVecMax0;


//
//	Vector Magnitude
//
typedef void (*vmp_QVecMagnitudeProc)(float * const pfD, const vmp3DQVector * const pvA);
extern vmp_QVecMagnitudeProc			vmp_QVecMagnitude;
extern vmp_QVecMagnitudeProc			vmp_QVecMagnitude0;
extern vmp_QVecMagnitudeProc			vmp_QVecMagnitudeFast;
extern vmp_QVecMagnitudeProc			vmp_QVecMagnitudeFast0;



//
//	Vector Normalization
//
typedef void (*vmp_QVecNormalizeProc)(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
extern vmp_QVecNormalizeProc			vmp_QVecNormalize;
extern vmp_QVecNormalizeProc			vmp_QVecNormalize0;
extern vmp_QVecNormalizeProc			vmp_QVecNormalizeFast;
extern vmp_QVecNormalizeProc			vmp_QVecNormalizeFast0;





#ifdef __cplusplus
}
#endif

#endif	//__QVsf3D_H


