  
//
//  Vsf3DEx.h - 3D (Quad) Math Special Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "vmp3D.h"
#include	"CpuAsm.h"



#ifndef __QVsf3DEx_H
#define __QVsf3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void QVsf3DSetup( const CpuInfo * const pcinfo );


void vmp_QVecSqrtGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);

void vmp_QVecSqrtFastAltivec(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);

void vmp_QVecMinGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMinAltivec(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );

void vmp_QVecMaxGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMaxAltivec(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );

void vmp_QVecMagnitudeGeneric(float * const pfD, const vmp3DQVector * const pvA);
void vmp_QVecMagnitudeAltivec(float * const pfD, const vmp3DQVector * const pvA);

void vmp_QVecNormalizeGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecNormalizeAltiec(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);



#ifdef __cplusplus
}
#endif

#endif	//__QVsf3DEx_H


