  
//
//  Vsf3D.h - 3D Math Special Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include	"vmp3D.h"


#ifndef __Vsf3D_H
#define __Vsf3D_H

#ifdef __cplusplus
extern "C" {
#endif



//                            | 1 0 0 0 |
//	Matrix - Set Identity     | 0 1 0 0 |
//                            | 0 0 1 0 |
//                            | 0 0 0 1 |
typedef void (*vmp_MatrixSetIdentityProc)( vmp3DMatrix * const pMatrix );
extern vmp_MatrixSetIdentityProc vmp_MatrixSetIdentity;



//
//	Vector Square Root
//
typedef void (*vmp_VecSqrtProc)(vmp3DVector * const pvD, const vmp3DVector * const pvA);
extern vmp_VecSqrtProc				vmp_VecSqrt;
extern vmp_VecSqrtProc				vmp_VecSqrt0;
extern vmp_VecSqrtProc				vmp_VecSqrtFast;
extern vmp_VecSqrtProc				vmp_VecSqrtFast0;


//
//	Vector Minimize
//
typedef void (*vmp_VecMinProc)( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
extern vmp_VecMinProc				vmp_VecMin;
extern vmp_VecMinProc				vmp_VecMin0;


//
//	Vector Maximize
//
typedef void (*vmp_VecMaxProc)( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
extern vmp_VecMaxProc				vmp_VecMax;
extern vmp_VecMaxProc				vmp_VecMax0;


//
//	Vector Magnitude
//
typedef void (*vmp_VecMagnitudeProc)(float * const pfD, const vmp3DVector * const pvA);
extern vmp_VecMagnitudeProc			vmp_VecMagnitude;
extern vmp_VecMagnitudeProc			vmp_VecMagnitude0;
extern vmp_VecMagnitudeProc			vmp_VecMagnitudeFast;
extern vmp_VecMagnitudeProc			vmp_VecMagnitudeFast0;



//
//	Vector Normalization
//
typedef void (*vmp_VecNormalizeProc)(vmp3DVector * const pvD, const vmp3DVector * const pvA);
extern vmp_VecNormalizeProc			vmp_VecNormalize;
extern vmp_VecNormalizeProc			vmp_VecNormalize0;
extern vmp_VecNormalizeProc			vmp_VecNormalizeFast;
extern vmp_VecNormalizeProc			vmp_VecNormalizeFast0;





#ifdef __cplusplus
}
#endif

#endif	//__Vsf3D_H


