  
//
//  Vsf3DEx.h - 3D Math Special Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "vmp3D.h"
#include	"CpuAsm.h"



#ifndef __Vsf3DEx_H
#define __Vsf3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void Vsf3DSetup( const CpuInfo * const pcinfo );


void vmp_VecSqrtGeneric(    vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtAltivec(    vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtFastAltivec(vmp3DVector * const pvD, const vmp3DVector * const pvA);

void vmp_VecMinGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMinAltivec(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );

void vmp_VecMaxGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMaxAltivec(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );

void vmp_VecMagnitudeGeneric(    float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeAltivec(    float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeFastAltivec(float * const pfD, const vmp3DVector * const pvA);

void vmp_VecNormalizeGeneric(    vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeAltivec(    vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeFastAltivec(vmp3DVector * const pvD, const vmp3DVector * const pvA);



#ifdef __cplusplus
}
#endif

#endif	//__Vsf3DEx_H


