
//
//	VTrig3DAltivec.cpp - 3D Vector Trignometric Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include "KariType.h"                                   // Master Definitions

	//	3rd Party Libraries
	
#include	<assert.h>
#include	<iostream.h>
#include    <math.h>

    //  Book Development Library Modules

#include	"vmp3D.h"
#include	"vmp3DEx.h"
#include	"VTrig3D.h"									// 3D Math
#include	"VTrig3DEx.h"



//	*** NOTE: Trignometric Functions are NOT supported by Altivec Instructions!
//		Use FPU!



//
//	Setup Vec3D module
//
//	NOTE: This function sets up the function vectors so the best function
//		is attached to the vector for the processor running.
//

void VTrig3DSetup( const CpuInfo * const pcinfo )
{
	ASSERT_PTR4(pcinfo);
	
    if ( CPUBITS_ALTIVEC & pcinfo->nBits )
      {
		vmp_FSinCos =				vmp_FSinCosGeneric;
		vmp_FSin =					vmp_FSinGeneric;
		vmp_FCos =					vmp_FCosGeneric;
		vmp_FTan =					vmp_FTanGeneric;
      }

	else
	  {
		vmp_FSinCos =				vmp_FSinCosGeneric;
		vmp_FSin =					vmp_FSinGeneric;
		vmp_FCos =					vmp_FCosGeneric;
		vmp_FTan =					vmp_FTanGeneric;
	  }
}





