  
//
//  Matrix3D.h - 3D Math Matrix Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include	"vmp3D.h"



#ifndef __VTrig3D_H
#define __VTrig3D_H

#ifdef __cplusplus
extern "C" {
#endif






//                            | 1 0 0 0 |
//	Matrix - Set Identity     | 0 1 0 0 |
//                            | 0 0 1 0 |
//                            | 0 0 0 1 |
typedef void (*vmp_MatrixSetIdentityProc)( vmp3DMatrix dMx );
extern vmp_MatrixSetIdentityProc vmp_MatrixSetIdentity;

//
//	Matrix - Set Translate
//

typedef void (*vmp_MatrixSetTranslateProc)( vmp3DMatrix dMx, float fTx, float fTy, float fTz );
extern vmp_MatrixSetTranslateProc vmp_MatrixSetTranslate;

//
//	Matrix - Set Rotation
//
typedef void (*vmp_MatrixSetRotateProc)( vmp3DMatrix dMx, float fRads );
extern vmp_MatrixSetRotateProc vmp_MatrixSetRotateX;
extern vmp_MatrixSetRotateProc vmp_MatrixSetRotateX0;
extern vmp_MatrixSetRotateProc vmp_MatrixSetRotateY;
extern vmp_MatrixSetRotateProc vmp_MatrixSetRotateY0;
extern vmp_MatrixSetRotateProc vmp_MatrixSetRotateZ;
extern vmp_MatrixSetRotateProc vmp_MatrixSetRotateZ0;



typedef void (*vmp_MatrixCopyProc)( vmp3DMatrix dMx, const vmp3DMatrix aMx );
extern vmp_MatrixCopyProc vmp_MatrixCopy;

typedef void (*vmp_MatrixMulProc)( vmp3DMatrix dMx, const vmp3DMatrix aMx, const vmp3DMatrix bMx );
extern vmp_MatrixMulProc vmp_MatrixMul;

typedef void (*vmp_MatrixTranslateProc)( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fTx, float fTy, float fTz );
extern vmp_MatrixTranslateProc vmp_MatrixTranslate;

typedef void (*vmp_MatrixRotateXProc)( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fRads );
extern vmp_MatrixRotateXProc vmp_MatrixRotateX;

typedef void (*vmp_MatrixRotateYProc)( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fRads );
extern vmp_MatrixRotateYProc vmp_MatrixRotateY;

typedef void (*vmp_MatrixRotateZProc)( vmp3DMatrix dMx, vmp3DMatrix aMx, float fRads );
extern vmp_MatrixRotateZProc vmp_MatrixRotateZ;



#ifdef __cplusplus
}
#endif

#endif	//__Matrix3D_H


