
//
//	Matrix3DAltivec.cpp - 3D Vector Matrix Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include "KariType.h"                                   // Master Definitions

	//	3rd Party Libraries
	
#include	<assert.h>
#include	<iostream.h>
#include    <math.h>

    //  Book Development Library Modules

#include	"vmp3D.h"
#include	"vmp3DEx.h"
#include	"Matrix3D.h"									// 3D Math
#include	"Matrix3DEx.h"



//
//	Setup Matrix3D module
//
//	NOTE: This function sets up the function vectors so the best function
//		is attached to the vector for the processor running.
//

void Matrix3DSetup( const CpuInfo * const pcinfo )
{
    if ( CPUBITS_ALTIVEC & pcinfo->nBits )
      {
		vmp_MatrixSetIdentity =		vmp_MatrixSetIdentityGeneric;

		vmp_MatrixSetTranslate =	vmp_MatrixSetTranslateGeneric;
		vmp_MatrixSetRotateX =		vmp_MatrixSetRotateXGeneric;
		vmp_MatrixSetRotateX0 =		vmp_MatrixSetRotateXGeneric;
		vmp_MatrixSetRotateY =		vmp_MatrixSetRotateYGeneric;
		vmp_MatrixSetRotateY0 =		vmp_MatrixSetRotateYGeneric;
		vmp_MatrixSetRotateZ =		vmp_MatrixSetRotateZGeneric;
		vmp_MatrixSetRotateZ0 =		vmp_MatrixSetRotateZGeneric;

		vmp_MatrixCopy =			vmp_MatrixCopyGeneric;
		vmp_MatrixMul =				vmp_MatrixMulGeneric;
		vmp_MatrixTranslate =		vmp_MatrixTranslateGeneric;
		vmp_MatrixRotateX =			vmp_MatrixRotateXGeneric;
		vmp_MatrixRotateY =			vmp_MatrixRotateYGeneric;
		vmp_MatrixRotateZ =			vmp_MatrixRotateZGeneric;
      }

	else
	  {
		vmp_MatrixSetIdentity =		vmp_MatrixSetIdentityGeneric;

		vmp_MatrixSetTranslate =	vmp_MatrixSetTranslateGeneric;
		vmp_MatrixSetRotateX =		vmp_MatrixSetRotateXGeneric;
		vmp_MatrixSetRotateX0 =		vmp_MatrixSetRotateXGeneric;
		vmp_MatrixSetRotateY =		vmp_MatrixSetRotateYGeneric;
		vmp_MatrixSetRotateY0 =		vmp_MatrixSetRotateYGeneric;
		vmp_MatrixSetRotateZ =		vmp_MatrixSetRotateZGeneric;
		vmp_MatrixSetRotateZ0 =		vmp_MatrixSetRotateZGeneric;

		vmp_MatrixCopy =			vmp_MatrixCopyGeneric;
		vmp_MatrixMul =				vmp_MatrixMulGeneric;
		vmp_MatrixTranslate =		vmp_MatrixTranslateGeneric;
		vmp_MatrixRotateX =			vmp_MatrixRotateXGeneric;
		vmp_MatrixRotateY =			vmp_MatrixRotateYGeneric;
		vmp_MatrixRotateZ =			vmp_MatrixRotateZGeneric;
	  }
}






