  
//
//  Matrix3DEx.h - 3D Math Matrix Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//		This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include	"CpuAsm.h"
#include	"vmp3D.h"


#ifndef __Matrix3DEx_H
#define __Matrix3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void Matrix3DSetup( const CpuInfo * const pcinfo );

void vmp_MatrixSetIdentityGeneric( vmp3DMatrix pMatrix );
void vmp_MatrixSetIdentityAltivec( vmp3DMatrix pMatrix );

void vmp_MatrixSetTranslateGeneric(vmp3DMatrix pM, float fTx, float fTy, float fTz );

void vmp_MatrixSetRotateXGeneric(vmp3DMatrix pM, float fRads );
void vmp_MatrixSetRotateXAltivec(vmp3DMatrix pM, float fRads );
											  
void vmp_MatrixSetRotateYGeneric(vmp3DMatrix pM, float fRads );
void vmp_MatrixSetRotateYAltivec(vmp3DMatrix pM, float fRads );

void vmp_MatrixSetRotateZGeneric(vmp3DMatrix pM, float fRads );
void vmp_MatrixSetRotateZAltivec(vmp3DMatrix pM, float fRads );



void vmp_MatrixCopyGeneric( vmp3DMatrix dMx, const vmp3DMatrix aMx );
void vmp_MatrixCopyAltivec( vmp3DMatrix dMx, const vmp3DMatrix aMx );

void vmp_MatrixMulGeneric( vmp3DMatrix dMx, const vmp3DMatrix aMx, const vmp3DMatrix bMx );
void vmp_MatrixMulAltivec( vmp3DMatrix dMx, const vmp3DMatrix aMx, const vmp3DMatrix bMx );

void vmp_MatrixTranslateGeneric( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fTx, float fTy, float fTz );
void vmp_MatrixTranslateAltivec( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fTx, float fTy, float fTz );

void vmp_MatrixRotateXGeneric( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fRads );
void vmp_MatrixRotateXAltivec( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fRads );

void vmp_MatrixRotateYGeneric( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fRads );
void vmp_MatrixRotateYAltivec( vmp3DMatrix dMx, const vmp3DMatrix aMx, float fRads );

void vmp_MatrixRotateZGeneric( vmp3DMatrix dMx, vmp3DMatrix aMx, float fRads );
void vmp_MatrixRotateZAltivec( vmp3DMatrix dMx, vmp3DMatrix aMx, float fRads );


#ifdef __cplusplus
}
#endif

#endif	//__Matrix3DEx_H


