
//
//  yuv12Ex.h - YUV12 bit to RGB Conversion
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//		This module is designed for fast 3D math
//
//  Created - 21 Feb, 2002 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include	"CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __yuv12Ex_H
#define __yuv12Ex_H

#ifdef __cplusplus
extern "C" {
#endif


void yuv12Setup( const CpuInfo * const pcinfo );


//
//	YUV12 to RGB Conversion
//

void vmp_yuv12PPCInit( void );

void vmp_yuv12toRGB32Generic(
	void *pImg, uint nWidth, uint nHeight, int iStride,
	const uint8 * pBaseY, uint nStrideY, 
	const uint8 * pBaseU, const uint8 * pBaseV, uint nStrideUV );

void vmp_yuv12toRGB32PPC(
	void *pImg, uint nWidth, uint nHeight, int iStride,
	const uint8 * pBaseY, uint nStrideY, 
	const uint8 * pBaseU, const uint8 * pBaseV, uint nStrideUV );

void vmp_yuv12toRGB32Altivec(
	void *pImg, uint nWidth, uint nHeight, int iStride,
	const uint8 * pBaseY, uint nStrideY, 
	const uint8 * pBaseU, const uint8 * pBaseV, uint nStrideUV );



#ifdef __cplusplus
}
#endif

#endif  //__yuv12Ex_H





