
//
//  CpuAsm.h - Cpu Detection - 
//
//  Cpu - PowerPC Cpu definitions
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//  Created - 25 Oct 2001 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions



#ifndef __CpuAsm_H
#define __CpuAsm_H

#ifdef __cplusplus
extern "C" {
#endif



//
//  CPU definition Id's
//

typedef enum
{
	CPU_OS9		=	9,			// OS9
	CPU_OSX		=   10			// OS10
} CPU;



//
//  CPU bit flags
//

typedef enum
{
	CPUBITS_ALTIVEC		=	0x00000001,					// AltiVec
	CPUBITS_GEKKO		=	0x00000002					// Gekko
} CPUBITS;



//
//  CPU Vendors
//

typedef enum
{
    CPUVEN_UNKNOWN      =   0,                          // Unknown
	CPUVEN_MOTOROLA		=	1,							// Motorola
	CPUVEN_IBM			=	2							// IBM
} CPUVEN;


//
//  Cpu Information
//

typedef struct CpuInfoType
{
    uint    nCpuId;                                     // Cpu type Identifier
    uint    nFpuId;                                     // Floating Point Unit Identifier
    uint    nBits;                                      // Feature Bits
    uint    nMfg;                                       // Manufacturer
} CpuInfo;



    //
    //  Function Prototypes
    //

void CpuDetect( CpuInfo * const pInfo );

#define CPU_SZBUF_MAX	80
char *CpuInfoStr( char *pszBuf, const CpuInfo * const pInfo );


#ifdef __cplusplus
}
#endif

#endif  //__CpuAsm_H

