
//
//  ram.h - Memory Module
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the memory management module header.
//
//  Created - 25 Jul, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include    "KariType.h"                                // Master Definitions
#include	"CpuAsm.h"


#ifndef RAM_H
#define RAM_H

#ifdef __cplusplus
extern "C" {
#endif


    //
    //  Function Prototypes
    //

//	map to ZeroMemory() or replace with a 32/64/128 + remainder write!
#define ramZero( ppMem, nReqSize )( memset( ppMem, 0, nReqSize ) )

void ramSetup( const CpuInfo * const pInfo );

void * ramAlloc( uint nReqSize );                   // malloc() wrapper
void ramFree( const void * const pRaw );            // free() wrapper


bool ramGet( byte ** const ppMem, uint nSize );     // Allocate memory

bool ramGetClr( byte ** const ppMem, uint nSize );  // Allocate memory (cleared)

void ramRelease( byte ** const ppMem );             // Free memory


#ifdef __cplusplus
}
#endif

#endif  //RAM_H





